
#ifndef __ATOMARRAY_H__
#define __ATOMARRAY_H__


#if C74_PRAGMA_STRUCT_PACKPUSH
    #pragma pack(push, 2)
#elif C74_PRAGMA_STRUCT_PACK
    #pragma pack(2)
#endif

// these structs are provided for debugging convenience, but 
// are subject to change, and should not be modified directly

typedef struct _atomarray
{
	t_object	ob;
	long		ac;
	t_atom		*av;
} t_atomarray;

#if C74_PRAGMA_STRUCT_PACKPUSH
    #pragma pack(pop)
#elif C74_PRAGMA_STRUCT_PACK
    #pragma pack()
#endif

#ifdef __cplusplus
	extern "C" {
#endif // __cplusplus

t_atomarray *atomarray_new(long ac, t_atom *av);						// copies input
t_max_err atomarray_setatoms(t_atomarray *x, long ac, t_atom *av);		// copies input
t_max_err atomarray_getatoms(t_atomarray *x, long *ac, t_atom **av);	// does not make a copy
t_max_err atomarray_copyatoms(t_atomarray *x, long *ac, t_atom **av);	// does make a copy
long atomarray_getsize(t_atomarray *x);
t_max_err atomarray_getindex(t_atomarray *x, long index, t_atom *av);
void *atomarray_duplicate(t_atomarray *x);
void atomarray_appendatom(t_atomarray *x, t_atom *a);
void atomarray_appendatoms(t_atomarray *x, long ac, t_atom *av);
void atomarray_chuckindex(t_atomarray *x, long index);
void atomarray_clear(t_atomarray *x);
void atomarray_funall(t_atomarray *x, method fun, void *arg);

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // __ATOMARRAY_H__
